##############################################################################
#
# Copyright (c) 2003 gocept gmbh & co. kg. All rights reserved.
#
# See also LICENSE.txt
#
##############################################################################
"""CMF link checker tool initalisation code

$Id: __init__.py,v 1.7 2005/01/22 14:03:41 ctheune Exp $"""

# Zope imports
from Products.CMFCore import utils as CMFutils
from Products.CMFCore import DirectoryView

# Linkchecker imports
from Products.CMFLinkChecker import LinkCheckerTool, \
    database, retrievemanager, reports
from Products.CMFLinkChecker import retrievers
linkchecker_globals = globals()

tools = (LinkCheckerTool.LinkCheckerTool, )

# Register skin directories
DirectoryView.registerDirectory('skins', linkchecker_globals)

def initialize(context):
    CMFutils.ToolInit('CMFLinkChecker Tool', tools=tools,
                product_name='CMFLinkChecker', icon="tool.png").initialize(context)
    
    context.registerClass(
        database.LinkDatabase,
        constructors = (
            database.manage_addLinkDatabase,
            ),
        container_filter = LinkManagerFilter
        )

    context.registerClass(
        reports.BaseReports,
        constructors = (
            reports.manage_addBaseReports,
            ),
        container_filter = LinkManagerFilter
        )

    context.registerClass(
        retrievemanager.RetrieveManager,
        constructors = (
            retrievemanager.manage_addRetrieveManager,
            ),
        container_filter = LinkManagerFilter
        )

def LinkManagerFilter(objectmanager):
    """Tools for the Link Manager should not be addable everywhere"""
    if objectmanager.meta_type != "CMF Linkchecker Tool":
        return False
    return True

