# Copyright (c) 2004-2005 gocept gmbh & co. kg
# See also LICENSE.txt
# $Id: test_normalizer.py,v 1.5 2005/01/27 09:04:27 zagy Exp $

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

import unittest

from Testing import ZopeTestCase

from Products.Archetypes.tests.common import *
from Products.Archetypes.tests.utils import *

from Products.CMFLinkChecker.tests.LinkCheckerTestCase import \
    LinkCheckerTestCase

#from Products.Archetypes.tests.test_sitepolicy import makeContent
from Products.CMFCore.utils import getToolByName


class CMFLinkCheckerTest(LinkCheckerTestCase):

    def test_normalization(self):
        # Test if relative link will get absolute in Database
        self.loginPortalOwner()
        portal = self.getPortal()
        pl = getToolByName(portal, 'portal_linkchecker')

        portal.invokeFactory('Document', 'doc1')
        
        doc1 = portal.doc1
        doc1.text='blah\n"indexhtml":index_html\nbumm'
        pl.retrieving.retrieveObject(doc1)
        db_cont = pl.database.query()
        self.assertEqual(1, len(db_cont))
        self.assertEqual(portal.absolute_url() + "/index_html", db_cont[0].url)

        
        ## assert '..' are stripped
    
        portal.invokeFactory('Folder', 'f1')
        portal.invokeFactory('Folder', 'f2')
        f1 = portal.f1
        f2 = portal.f2
        f1.invokeFactory('Document', 'f1d')
        f2.invokeFactory('Document', 'f2d')
        f1d = f1.f1d
        
        f1d.text = '"relativeref":../f2/f2d"'
        uid = pl.getUIDForObject(f1d)
        pl.retrieving.retrieveObject(f1d)
        
        db_cont = pl.database.query(objects=[uid])
        self.assertEquals(1, len(db_cont))
        self.assertEqual(portal.absolute_url() + "/f2/f2d",
                         db_cont[0].url)

    def test_relativestrip(self):
        from Products.CMFLinkChecker.utils import stripRelativeFromUrl
        s = stripRelativeFromUrl

        self.assertEquals('http://nohost/foo',
                          s('http://nohost/bla/fasel/../../foo'))

def test_suite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(CMFLinkCheckerTest))
    return suite

if __name__ == '__main__':
    framework()

